<?
class CAbudagovSms
{

    private static function sendToApi ($arParams) {
        if (
            strlen($arParams['TOKEN']) > 3 &&
            strlen($arParams['DEVICE']) > 3 &&
            strlen($arParams['PHONE']) > 3 &&
            strlen($arParams['TEXT']) > 0
        ) {
            foreach ($arParams as $name => $value) {
                $arParams[$name] = urlencode($value);
            }
            $obHttp = new CHTTP();
            $obHttp->Get('https://semysms.net/api/3/sms.php?token='.$arParams['TOKEN'].'&device='.$arParams['DEVICE'].'&phone='.$arParams['PHONE'].'&msg='.$arParams['TEXT']);
        }
    }


    function smsSend (&$arFields, $arTemplate)
    {

        if ($arTemplate['LID']) {
            $siteId  = $arTemplate['LID'];
        } else {
            $siteId  = SITE_ID;
        }

        if (COption::GetOptionString('abudagov.sms', "ACTIVE", false, $siteId) == 'Y' && !$arFields['DUPLICATE']) {

            $arSmsEvents = array(
                'NEW_ORDER',
                'DELIVERY_ORDER',
                'PAY_ORDER'
            );

            if (CModule::IncludeModuleEx('abudagov.sms') > 1) {
                $arSmsEvents = array('NEW_ORDER');
            }

            foreach ($arSmsEvents as $smsEventCode) {
                if ($arTemplate['EVENT_NAME'] == COption::GetOptionString('abudagov.sms', $smsEventCode . "_EVENT", false, $siteId)) {
                    $arParams = array(
                        'TOKEN' => COption::GetOptionString('abudagov.sms', "TOKEN", '', $siteId),
                        'DEVICE' =>  COption::GetOptionString('abudagov.sms', "DEVICE", '', $siteId),
                        'ADMIN_PHONE' => COption::GetOptionString('abudagov.sms', "ADMIN_PHONE", '', $siteId),
                        'NAME' => $smsEventCode,
                        'EVENT_NAME' => $arTemplate['EVENT_NAME'],
                        'COPY_CLIENT' => COption::GetOptionString('abudagov.sms', $smsEventCode . "_COPY_CLIENT", false, $siteId),
                        'COPY_ADMIN' => COption::GetOptionString('abudagov.sms', $smsEventCode . "_COPY_ADMIN", false, $siteId),
                        'TEXT' => COption::GetOptionString('abudagov.sms', $smsEventCode . "_TEXT", false, $siteId)
                    );

                    if (!$arFields['SERVER_NAME' && defined('SITE_SERVER_NAME')]) {
                        $arFields['SERVER_NAME'] = SITE_SERVER_NAME;
                    }
                    if (!$arFields['SERVER_NAME']) {
                        $arFields['SERVER_NAME'] = $_SERVER['SERVER_NAME'];
                    }
                    // Delaem zamenu poley
                    foreach ($arFields as $name => $value) {
                        $arParams['TEXT'] = str_replace('#' . $name . '#', $value, $arParams['TEXT']);
                    }

                    // Poluchaem telefon klienta
                    if ($arParams['COPY_CLIENT'] == 'Y' && $arFields['ORDER_ID']) {

                        \Bitrix\Main\Loader::includeModule('sale');

                        $dbOrder = \Bitrix\Sale\Internals\OrderTable::getList(array(
                            'filter' => array('ACCOUNT_NUMBER' => $arFields['ORDER_ID'])
                        ));
                        if ($arOrder = $dbOrder->fetch()) {
                            $orderId = $arOrder['ID'];
                        } else {
                            $orderId = $arFields['ORDER_ID'];
                        }

                        $order = \Bitrix\Sale\Order::load($orderId);
                        $propertyCollection = $order->getPropertyCollection();
                        $arParams['PHONE'] = $propertyCollection->getPhone()->getValue();
                        CAbudagovSms::sendToApi($arParams);
                    }

                    // Otpravlyaem adminu
                    if ($arParams['COPY_ADMIN'] == 'Y' && strlen($arParams['ADMIN_PHONE']) > 3) {
                        $arParams['PHONE'] = $arParams['ADMIN_PHONE'];
                        CAbudagovSms::sendToApi($arParams);
                    }
                }
            }
        }
    }
}
?>