<?
IncludeModuleLangFile(__FILE__);
Class abudagov_sms extends CModule
{
	var $MODULE_ID = 'abudagov.sms';
	var $MODULE_VERSION;
	var $MODULE_VERSION_DATE;
	var $MODULE_NAME;
	var $MODULE_DESCRIPTION;
	var $MODULE_CSS;
	var $PARTNER_NAME;
	var $PARTNER_URI;
	var $strError = '';

	function __construct()
	{
		global $USER;
		$arModuleVersion = array();
		include(dirname(__FILE__)."/version.php");
		$this->MODULE_VERSION = $arModuleVersion["VERSION"];
		$this->MODULE_VERSION_DATE = $arModuleVersion["VERSION_DATE"];
		$this->MODULE_NAME = GetMessage("abudagov.sms_MODULE_NAME");
		$this->MODULE_DESCRIPTION = GetMessage("abudagov.sms_MODULE_DESC");
		$this->PARTNER_NAME = GetMessage("abudagov.sms_PARTNER_NAME");
		$this->PARTNER_URI = GetMessage("abudagov.sms_PARTNER_URI");
	}

	function InstallDB($arParams = array())
	{
		return true;
	}

	function UnInstallDB($arParams = array())
	{
		return true;
	}

	function InstallEvents()
	{
        RegisterModuleDependences("main", "OnBeforeEventSend", $this->MODULE_ID, "CAbudagovSms", "smsSend");

		return true;
	}

	function UnInstallEvents()
	{
        UnRegisterModuleDependences("main", "OnBeforeEventSend", $this->MODULE_ID, "CAbudagovSms", "smsSend");

		return true;
	}

	function InstallFiles($arParams = array())
	{

        if (is_dir($p = $_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/" . $this->MODULE_ID . "/admin")) {
            if ($dir = opendir($p)) {
                while (false !== $item = readdir($dir)) {
                    if ($item == ".." || $item == "." || $item == "menu.php")
                        continue;
                    file_put_contents(
                        $file = $_SERVER["DOCUMENT_ROOT"] . "/bitrix/admin/" . $this->MODULE_ID . "_" . $item,
                        "<?php" . "\n" . 'require ($_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/' . $this->MODULE_ID
                        . '/admin/' . $item . '");' . "\n" . "?>"
                    );
                }
                closedir($dir);
            }
        }

		return true;
	}

	function UnInstallFiles()
	{
        if (is_dir($p = $_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/" . $this->MODULE_ID . "/admin")) {
            if ($dir = opendir($p)) {
                while (false !== $item = readdir($dir)) {
                    if ($item == ".." || $item == ".")
                        continue;
                    unlink($_SERVER["DOCUMENT_ROOT"] . "/bitrix/admin/" . $this->MODULE_ID . "_" . $item);
                }
                closedir($dir);
            }
        }

		return true;
	}

	function DoInstall()
	{
		global $APPLICATION;

		if ($this->InstallDB()) {
			RegisterModule($this->MODULE_ID);
			$this->InstallFiles();
			$this->InstallEvents();
		}
	}

	function DoUninstall()
	{
		global $APPLICATION;

        $this->UnInstallEvents();
		$this->UnInstallDB();
        $this->UnInstallFiles();
		UnRegisterModule($this->MODULE_ID);
	}
}
?>
